#ifndef JALBCLIENT_H
#define JALBCLIENT_H

#include "jalbArrayList.h"

#include "jalbTerrain.h"
#include "jalbEntity.h"

struct jalbServer {
    char name[256];
    char address[256];

    char username[256];
    char password[256];
};

enum serverOutput {
    soWakeup = 0,
    soNewGood,
    soNewBad,
    soLogGood,
    soLogBad,
    soInitTer,
    soInitEnt,
    soDisconnect,
    soUpdate,
    soTerUpdate,
    soEntUpdate,

    soNumOutputs,
};

enum entSubIds {
    soEntLoc = 0,
    soEntRot,
};

enum terSubIds {
    soTerVertMove = 0,
    soTerVertAdd,
    soTerFaceAdd,
};

enum clientOutput {
    coWakeup = 0,
    coNewAccount,
    coLogin,
    coDisconnect,
    coUpdate,
    coGameTic,

    coNumOutputs,
};

enum clientOutSub {
    cosKey = 0,
    cosMouse,
    cosSetRots,
};

// All stages after csOption cause tic to read input.
enum clientStage {
    csMain = 0,
    csEdit,
    csOption,
    csWakeupCreate,
    csWakeupLogin,
    csWoke,
    csRecvInit,
    csLoadModel,
    csLoadTexture,
    csGame,
};

int myConnect(char *address);

// Returns sfd.
int sendWakeUp(struct jalbServer *ser, int sfd, unsigned char *buf);
void sendCreateAccount(struct jalbServer *ser, int sfd, unsigned char *buf);
void sendLogIn(struct jalbServer *ser, int sfd, unsigned char *buf, int chunkRadius);
void sendUpdate(int sfd, unsigned char *buf, unsigned char *key);

void intToBuffer(int i, unsigned char *buff);
int buffToInt(unsigned char *buff);

/** Data In */
int recvTer(unsigned char *buff, int length, ArrayList *terList);
int recvTerMin(unsigned char *buff, int length, ArrayList *terList);
int recvTerList(unsigned char *buff, int length, ArrayList *terList);

int recvEnts(unsigned char *buff, int length, ArrayList *entList);

void sendDisconnect(unsigned char *buf, int sfd, unsigned char *key);

#endif // JALBCLIENT_H
