#ifndef JALBMODEL_H
#define JALBMODEL_H

#include <gl.h>

struct jalbModel {
    // dimensions = 1 if only verts, = 2 if verts and UVs, = 3 is verts, UV,s and norms
    GLuint          dimensions;
    GLuint          numVerts; /*Number of unique verts*/
    GLuint          numFaces; /*UVs and faces have the same length. (not size)*/
    GLuint          *faces;
    GLfloat         *verts;
    GLfloat         *UVs;
    GLuint          tex;
};

struct jalbCamera {
    // jalbModel   *model;
    GLfloat     distance;
    GLfloat     rots[3];

// If the camera is following a character then set this pointer equal to the characters pointer.
    GLfloat     *followVect;
};

/** Model */
struct jalbModel *jalbInitModel();
void jalbFreeModel(struct jalbModel *model);
void jalbReadModel(char* filename, struct jalbModel *model);
struct jalbModel *jalbMakeModel(char* filename, int tex);

/** Camera Matrix */
void genCamTransMatrix3rd(struct jalbCamera *cam, float *matTrans);
void genCamTransVect3rd(struct jalbCamera *cam, float *vect);

/** Camera */

struct jalbCamera *initCam();

#endif // JALBMODEL_H
