#version 430 core

in int gl_VertexID;

// Input vertex data, different for all executions of this shader.
layout(location = 0) in vec3 vertexPosition;
layout(location = 1) in vec2 vertexUV0;
layout(location = 2) in vec2 vertexUV1;
layout(location = 3) in vec2 vertexUV2;

// Output data ; will be interpolated for each fragment.
out vec2 UV0;
out vec2 UV1;
out vec2 UV2;
out vec3 alphas;

// Values that stay constant for the whole mesh.
uniform mat4 MVP;

void main(){
	// Output position of the vertex, in clip space : MVP * position
	gl_Position =  MVP * vec4(vertexPosition,1);
	gl_Position.xy = gl_Position.xy / gl_Position.w;
	gl_Position.w = 1;
//	gl_Position = vec4(vertexPosition,1);

	int div = gl_VertexID / 3;
	int id = gl_VertexID - (div * 3);

	UV0 = vertexUV0;
	UV1 = vertexUV1;
	UV2 = vertexUV2;
	
	alphas[0] = 0;
	alphas[1] = 0;
	alphas[2] = 0;
	alphas[id] = 1;

	// Flips the y of the UV coord.
	// UV = vec2(vertexUV.x, 1.0-vertexUV.y);
}

