#include "jalbAnimMap.h"

struct jalbAnimMap *initAnimMap(SDL_Texture *tex, int texW, int texH, int rows, int cols, int totFrame) {
    struct jalbAnimMap *animMap = malloc(sizeof(struct jalbAnimMap));

    animMap->tex = tex;

    animMap->cols = cols;
    animMap->rows = rows;

    animMap->curFrame = 0;
    animMap->totFrame = totFrame;

    animMap->width = texW / cols;
    animMap->height = texH / rows;

    animMap->lastUpdate = SDL_GetTicks();
    animMap->waitTime = 200;

    return animMap;
}

void animMapRender(struct jalbAnimMap *animMap, int x, int y, SDL_Renderer *renderer) {
    SDL_Rect rect;
    rect.x = x;
    rect.y = y;
    rect.w = animMap->width;
    rect.h = animMap->height;

    SDL_Rect srcrect;

    int h = animMap->curFrame / animMap->rows;
    int w = animMap->curFrame - h * animMap->rows;

    srcrect.x = w * animMap->width;
    srcrect.y = h * animMap->height;
    srcrect.w = animMap->width;
    srcrect.h = animMap->height;

    SDL_RenderCopy(renderer, animMap->tex, &srcrect, &rect);

    if(SDL_GetTicks() > animMap->lastUpdate + animMap->waitTime) {
        animMap->lastUpdate = SDL_GetTicks();
        animMap->curFrame++;

        if(animMap->curFrame >= animMap->totFrame) {
            animMap->curFrame = 0;
        }
    }
}
