#ifndef JALBARRAYLIST_H
#define JALBARRAYLIST_H

#include <stdio.h>

typedef struct ArrayList {
    // How many elements i put into the data.
    int filled;
    // Hey many elemets can fit into the data.
    int numElements;
    // Size of one element. (in bytes)
    int elementSize;
    // Pointer to the array.
    void *data;
    // Pointer to the next segment of the list.
    struct ArrayList *next;
} ArrayList;

ArrayList *initArrayList(int eleNums, int eleSize);
void freeArrayList(ArrayList *al);
void freeArrayListPointer(ArrayList *al);

void arrayListAddEnd(ArrayList *al, void *data);
void arrayListAddEndPointer(ArrayList *al, void *data);

void arrayListSet(ArrayList *al, int index, void *data);

void arrayListDisplay(ArrayList *al);
void arrayListDisplayInt(ArrayList *al);

int arrayListGetInt(ArrayList *al, int index);
void *arrayListGetPointer(ArrayList *al, int index);
void *arrayListGetEndPointer(ArrayList *al);

void *arrayListSwitchPointer(ArrayList *al, int index, void *pointer);

int isArrayListSumGreater(ArrayList *al, int compare);

void removeArrayListEnd(ArrayList *al);
void arrayListRemove(ArrayList *al, int i);

int sizeOfArrayList(ArrayList *al);
int arrayListGetLength(ArrayList *al);

void saveArrayListInt(ArrayList *al, FILE *file);
void loadArrayListInt(ArrayList *al, FILE *file);

int arrayListAddUnique(ArrayList *al, void *data);
void *arrayListDataPointer(ArrayList *al, int index);
int arrayListContain(ArrayList *al, void *data);

#endif // JALBARRAYLIST_H
