#ifndef JALBBUTTONARRAY_H
#define JALBBUTTONARRAY_H

#include <SDL.h>
#include <SDL_image.h>
#include "SDL_ttf.h"

struct buttonArray {
    int x;
    int y;

    int width;
    int height;

    int fontW;
    int fontH;

    int buttH;
    int edgeW;

    int cols;
    int rows;

    // An array of the textures of the strings.
    SDL_Texture **textures;
    int *textureWs;
};

struct buttonArray *initButtonArray(int x, int y, int width, int fontW, int fontH, int buttH, int edgeW, int cols, int rows);
void freeButtonArray(struct buttonArray *buttAr);

void buttArSetText(struct buttonArray *ba, SDL_Renderer *renderer, char *str, int buttX, int buttY, SDL_Color *color, TTF_Font *font);
void buttArRender(struct buttonArray *ba, SDL_Renderer *renderer);
void buttArRenderCursor(struct buttonArray *ba, SDL_Renderer *renderer, int buttSelected, int cursorIndex, int cursorW, int cursorH);
int buttArClick(struct buttonArray *ba, int mx, int my);
void buttArFree(struct buttonArray *buttAr);

#endif // JALBBUTTONARRAY_H
