#ifndef JALBSCROLLLIST_H
#define JALBSCROLLLIST_H

#include <SDL.h>
#include <SDL_image.h>
#include "SDL_ttf.h"
#include <string.h>

#include "jalbArrayList.h"

struct scrollList {
    int x;
    int y;

    int width;
    int height;

    int fontW;
    int fontH;

    int edgeW;

    int numCols;

    int numButts;

    int rowsPerButt;

//    ArrayList *aList;
    ArrayList *textList;
    ArrayList *widthList;

    int yIndent;
    int maxYindent;

    int rightText;
};

struct scrollBar {
    int x;
    int y;

    int yIndent;
    // yMax = drawH - renderH

    // Height to render to
    int screenH;
    // Height that needs to be drawn.
    int drawH;

    // barH = renderH^2 / drawH
    int barH;
};

struct scrollList *initScrollList(int x, int y, int width, int height, int fontW, int fontH, int edgeW, int rowsPerButt, int rightText);

void scrollListAddButt(struct scrollList *sl);
void scrollListSetText(struct scrollList *sl, char *str, int buttIndex, int rowIndex, SDL_Color *color, SDL_Renderer *renderer, TTF_Font *font);

//void scrollListAddServer(struct scrollList *sl, struct jalbServer *serv);
void scrollListRender(struct scrollList *sl, SDL_Renderer *renderer, TTF_Font *font, SDL_Color *color, int highlighted);
int scrollListClickButt(struct scrollList *sl, int mx, int my);

int scrollListClickBar(struct scrollList *sl, int mx, int my);
void scrollListRemove(struct scrollList *sl, int index);

struct scrollBar *initScrollBar(int screenHeight, int drawHeight, int x, int y);
void scrollBarRender(struct scrollBar *sb, SDL_Renderer *renderer);
int scrollBarClick(struct scrollBar *sb, int mx, int my);
void scrollBarDrag(struct scrollBar *sb, int relY);

#endif // JALBSCROLLLIST_h
