#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#include <SDL.h>
#include <SDL_image.h>
#include "SDL_ttf.h"

#include "jalbTextBox.h"

/** Text Box */

struct textBox *initTextBox(int x, int y, int width, int height, int fontW, int fontH) {
    struct textBox *tb = malloc(sizeof(struct textBox));

    tb->x = x;
    tb->y = y;

    tb->width = width;
    tb->height = height;

    tb->fontW = fontW;
    tb->fontH = fontH;

    tb->topLine = 0;

    tb->numCols = width / fontW;
    tb->numRows = height / fontH;

    tb->textures = calloc(tb->numRows, sizeof(SDL_Texture*));
    tb->textureWs = malloc(tb->numRows * sizeof(int));

    return tb;
}

void txtBoxAddString(struct textBox *tb, char *str, int strLen, TTF_Font *font, SDL_Color *color, SDL_Renderer* renderer) {
//    strLen = 0;
//    int strI = 0;
//    while(str[strI] != '\0'){
//            printf("notNull\n");
//        strLen++;
//    }
    if(strLen > tb->numCols) {
        int startLine = 0;
        printf("lineTooLong\n");

        // Break it into multiple parts by word
        int lastStart = 0;
        int lastEnd = 0;

        int i = 0;
        // Iterate the string, to find the space right before the end of line.
        while(i < strLen) {
            if(i - lastStart > tb->numCols) {
                printf("its past\n");
                // New Line.
                // Turn the string, last end to last start into a texture.
                // then save the texture and move on.

                char temp = str[lastEnd];
                str[lastEnd] = '\0';

                SDL_Surface *txt = TTF_RenderText_Blended(font, &str[lastStart], *color);
                SDL_Texture *tx = SDL_CreateTextureFromSurface(renderer, txt);

                SDL_FreeSurface(txt);

                str[lastEnd] = temp;

                if(tb->textures[tb->topLine] != NULL) {
                    SDL_DestroyTexture(tb->textures[tb->topLine]);
                }

                if(startLine != 0) {
                    printf("notEq\n");
                    // Iterate backwards. Setting this to the one before it.
                    // And so on, but the complicated part is that if new top is 0. meaning the last edited were numRows.
                    int j;
                    for(j = 0; j < startLine; j++) {
                        int last = tb->topLine - 1 - j;
                        int beforeLast = tb->topLine - j;
                        if(last < 0) {
                            last += tb->numRows;
                        }
                        if(beforeLast < 0) {
                            beforeLast += tb->numRows;
                        }
                        printf("tb->topLine: %d\n", tb->topLine);
                        printf("last: %d\n", last);
                        tb->textures[beforeLast] = tb->textures[last];
                        tb->textureWs[beforeLast] = tb->textureWs[last];

                        tb->textures[last] = tx;
                        tb->textureWs[last] = lastEnd - lastStart;
                    }
                } else {
                    tb->textures[tb->topLine] = tx;
                    tb->textureWs[tb->topLine] = lastEnd - lastStart;
                }

                tb->topLine++;

                if(tb->topLine >= tb->numRows) {
                    tb->topLine = 0;
                }

                lastStart = lastEnd + 1;
                startLine++;
            }
            if(str[i] == ' ') {
                printf("spaceSet\n");
                lastEnd = i;
            }
            i++;
        }
        printf("whileOver\n");
        if(lastStart < strLen) {
//            lastStart++;
            printf("moreToWrite: %s\n", &str[lastStart]);

            SDL_Surface *txt = TTF_RenderText_Blended(font, &str[lastStart], *color);
            SDL_Texture *tx = SDL_CreateTextureFromSurface(renderer, txt);
//                str[lastEnd + 1] = temp;
            SDL_FreeSurface(txt);
            if(tb->textures[tb->topLine] != NULL) {
                SDL_DestroyTexture(tb->textures[tb->topLine]);
            }

            if(startLine != 0) {
                printf("notEq\n");
                // Iterate backwards. Setting this to the one before it.
                // And so on, but the complicated part is that if new top is 0. meaning the last edited were numRows.
                int j;
                for(j = 0; j < startLine; j++) {
                    int last = tb->topLine - 1 - j;
                    int beforeLast = tb->topLine - j;
                    if(last < 0) {
                        last += tb->numRows;
                    }
                    if(beforeLast < 0) {
                        beforeLast += tb->numRows;
                    }
                    printf("tb->topLine: %d\n", tb->topLine);
                    printf("last: %d\n", last);
                    tb->textures[beforeLast] = tb->textures[last];
                    tb->textureWs[beforeLast] = tb->textureWs[last];

                    tb->textures[last] = tx;
                    tb->textureWs[last] = strLen - lastStart;
                }
            } else {
                tb->textures[tb->topLine] = tx;
                tb->textureWs[tb->topLine] = strLen - lastStart;
            }
            tb->topLine++;

            if(tb->topLine >= tb->numRows) {
                tb->topLine = 0;
            }
        }
    } else {
        SDL_Surface *txt = TTF_RenderText_Blended(font, str, *color);
        SDL_Texture *tx = SDL_CreateTextureFromSurface(renderer, txt);
        SDL_FreeSurface(txt);
        if(tb->textures[tb->topLine] != NULL) {
            SDL_DestroyTexture(tb->textures[tb->topLine]);
        }

        tb->textures[tb->topLine] = tx;
        tb->textureWs[tb->topLine] = strLen;
        tb->topLine++;

        if(tb->topLine >= tb->numRows) {
            tb->topLine = 0;
        }
    }
}

void txtBoxRender(struct textBox *tb, SDL_Renderer* renderer) {

    SDL_Rect srcrect;
    srcrect.x = 0;
    srcrect.y = 0;

    srcrect.h = tb->fontH;

    SDL_Rect dstrect;
    dstrect.x = tb->x;
    dstrect.y = tb->y;

    dstrect.h = tb->fontH;

    int i;
    for(i = tb->topLine - 1; i >= 0; i--) {
//        printf("tb->textureWs[i]: %d\n", tb->textureWs[i]);
        srcrect.w = tb->fontW * tb->textureWs[i];
        dstrect.w = tb->fontW * tb->textureWs[i];

        SDL_RenderCopy(renderer, tb->textures[i], &srcrect, &dstrect);

        dstrect.y += tb->fontH;
    }
    for(i = tb->numRows - 1; i >= tb->topLine; i--) {
        srcrect.w = tb->fontW * tb->textureWs[i];
        dstrect.w = tb->fontW * tb->textureWs[i];

        SDL_RenderCopy(renderer, tb->textures[i], &srcrect, &dstrect);

        dstrect.y += tb->fontH;
    }
}

void txtBoxFree(struct textBox *textB) {
    int i;
    for(i = 0; i < textB->numRows; i++) {
        if(textB->textures[i]) {
            printf("freeTex: %d\n", i);
            SDL_DestroyTexture(textB->textures[i]);
        }
    }
    free(textB->textures);
    free(textB->textureWs);

    free(textB);
}

