#ifndef JALBTEXTBOX_H
#define JALBTEXTBOX_H

#include <SDL.h>
#include <SDL_image.h>
#include "SDL_ttf.h"


struct textBox {
    int x;
    int y;

    int width;
    int height;

    int fontW;
    int fontH;

    int numRows;
    int numCols;

    int topLine;

    // An array of the textures of the strings.
    SDL_Texture **textures;
    int *textureWs;
};

// Text Box
struct textBox *initTextBox(int x, int y, int width, int height, int fontW, int fontH);
void txtBoxAddString(struct textBox *tb, char *str, int strLen, TTF_Font *font, SDL_Color *color, SDL_Renderer* renderer);
void txtBoxRender(struct textBox *tb, SDL_Renderer* renderer);
void txtBoxFree(struct textBox *textB);

#endif // JALBTEXTBOX_H
