#include <stdlib.h>
#include <stdio.h>
#include <string.h>

#include <math.h>

#include "jalbArrayList.h"
#include "jalbEntity.h"
#include "jalbGravity.h"

// Returns -1 if there is no file, else returns numEnts the file tells it.
int loadEntityList(char *dir, ArrayList *entList) {
    // Entities
    FILE *file;
    file = fopen(dir, "r");
    if(file == NULL ) {
        printf("L Ents: error opening file\n");
        return -1;
    }

    int numEnts;
    fread(&numEnts, sizeof(int), 1, file);

    int i;
    for(i = 0; i < numEnts; i++) {
        struct jalbEntity *ent = malloc(sizeof(struct jalbEntity));
        ent->gravMem = malloc(sizeof(struct jalbGravity));

        fread(&ent->modelIndex, sizeof(int), 1, file);
        fread(&ent->scale, sizeof(float), 1, file);
        fread(ent->gravMem->position, sizeof(float), 3, file);
        fread(ent->gravMem->moveVect, sizeof(float), 3, file);
//        ent->velVect[0] = 0;
//        ent->velVect[1] = 0;
//        ent->velVect[2] = 0;
        // Need to load loc, and velVect.
        // Later will just be gravObj.
    }
    return numEnts;
}

int saveEntityList(char *dir, ArrayList *entList) {
    // Entities
    FILE *file;
    file = fopen(dir, "r");
    if(file == NULL ) {
        printf("error opening file\n");
        return -1;
    }

    int numEnts;
    fread(&numEnts, sizeof(int), 1, file);

    int i;
    for(i = 0; i < numEnts; i++) {
        struct jalbEntity *ent = malloc(sizeof(struct jalbEntity));

        fread(&ent->modelIndex, sizeof(int), 1, file);
        fread(&ent->scale, sizeof(float), 1, file);
        fread(ent->gravMem->position, sizeof(float), 3, file);
        fread(ent->gravMem->moveVect, sizeof(float), 3, file);
        ent->gravMem->tempVect[0] = 0;
        ent->gravMem->tempVect[1] = 0;
        ent->gravMem->tempVect[2] = 0;
        // Need to load loc, and velVect.
        // Later will just be gravObj.
    }
    return numEnts;
}

