#include <math.h>

#include "jama.h"
// vectNormalize()
#include "jalbAnimMap.h"
//#include "rayFace.h"
#include "jalbTerrain.h"
#include "jalbEntity.h"
#include "rayFace.h"
#include "jalbGravity.h"

int counter0 = 0;

int debug = 1;
int maxRec = 10;

float jalbGravTerrainScale = 10;
int jalbGravTerrainEdge = 5;

int landed = 0;

// Computes the face and barys of the memObj. Must set position and chunkCoords beforehand.
void setjalbGravity(struct jalbGravity *memObj, ArrayList *ters) {
    float indentRadius = .51;
    float groundedDetectRadius = .55;
    // If the unit loc is not known, then detect it.
    polyGrounded(memObj, groundedDetectRadius, ters);

    // Not in the air.
    // If the unit is off a face, then move it to the closest part of that face.
    struct jalbTerrain *chunk = memObj->terArray[0];

//    printf("chunk: %p\n", chunk);
//    printf("chunk->numVerts: %d\n", chunk->numVerts);
//
//    printf("memObj->faceIndex: %d\n", memObj->faceIndex);

    if(memObj->typeIndex == 7) {
//        printf("entInAir\n");
        return;
    }

    if(memObj->typeIndex == 0) {
        // On face.
        return;
    }
    // The ent is off an edge or corner, so move them onto the face.

    float *f0 = chunk->verts[chunk->faces[memObj->faceIndex *3 + 0]].loc;
    float *f1 = chunk->verts[chunk->faces[memObj->faceIndex *3 + 1]].loc;
    float *f2 = chunk->verts[chunk->faces[memObj->faceIndex *3 + 2]].loc;

    float v[3];
    float u[3];
    vectSub(f1, f0, v, 3);
    vectSub(f2, f0, u, 3);

    float normal[3];
    crossProd3(v, u, normal);

    vectScaleTo(normal, indentRadius, 3);

    float *barys = memObj->barys;

    switch(memObj->typeIndex) {
    case 1:
        ;
        // edge 0.
        // Use barys[0] as scalar of edge0.

        // I need to move the characterPosition over to a face.
        // Do i want to have a moveVect that gets saved and set at the end. So i dont need to pass the detectLoc and the actual unitLoc.

        // where i want the unit loc to be.
        memObj->position[0] = f0[0] + v[0] * barys[0];
        memObj->position[1] = f0[1] + v[1] * barys[0];
        memObj->position[2] = f0[2] + v[2] * barys[0];

        // Now the character is in the right spot. Set memory. Begin movement.

        barys[1] = 0.0;

        break;
    case 2:
        memObj->position[0] = f0[0] + u[0] * barys[0];
        memObj->position[1] = f0[1] + u[1] * barys[0];
        memObj->position[2] = f0[2] + u[2] * barys[0];

        barys[1] = barys[0];
        barys[0] = 0.0;

        break;
    case 3:
        ;
        float v2[3];
        vectSub(f2, f1, v2, 3);

        memObj->position[0] = f1[0] + v2[0] * barys[0];
        memObj->position[1] = f1[1] + v2[1] * barys[0];
        memObj->position[2] = f1[2] + v2[2] * barys[0];

        // Figure the barys from the scalar.

        break;
    case 4:
        barys[0] = 0.0;
        barys[1] = 0.0;
        memObj->position[0] = f0[0] + normal[0];
        memObj->position[1] = f0[1] + normal[1];
        memObj->position[2] = f0[2] + normal[2];
        break;
    case 5:
        barys[0] = 1.0;
        barys[1] = 0.0;
        memObj->position[0] = f1[0] + normal[0];
        memObj->position[1] = f1[1] + normal[1];
        memObj->position[2] = f1[2] + normal[2];
        break;
    case 6:
        barys[0] = 0.0;
        barys[1] = 1.0;
        memObj->position[0] = f2[0] + normal[0];
        memObj->position[1] = f2[1] + normal[1];
        memObj->position[2] = f2[2] + normal[2];
        break;
    case 0:
        // On face.
        break;
    }
}

// Im either trying not to move, or go max speed.
void makeMoveVect(struct jalbGravity *gravObj) {
//    sayVect("makeMoveVect Move", gravObj->moveVect, 3);
//    sayVect("makeMoveVect Temp", gravObj->tempVect, 3);
//    printf("gravObj->StartMoveSpeed: %f\n", gravObj->curMoveSpeed);

    float littleG = -.6;
    if (gravObj->typeIndex == 7) {
        // In the air.
        // Dont take input's, just use momentum.
        float addVec[3] = {0, littleG, 0};
        addMoveVec(gravObj, addVec);
        return;
    }
    // gMemTempVect is normalized, i want gMemMoveVect to be too.
    // This funct handles ipdates curMoveSpeed
    // Should i just completely ignore y? Even from mag calcs.

    // If both zero then do slow check.
    if(gravObj->tempVect[0] == 0 && gravObj->tempVect[2] == 0) {
        if(gravObj->curMoveSpeed > gravObj->addMoveSpeed) {
            // Scale delta to be addMag, then add it to cur.
            gravObj->curMoveSpeed -= gravObj->addMoveSpeed;
        } else {
            gravObj->curMoveSpeed = 0;
        }
    } else {
        // curMoveSpeed in the old direction, + add move speed, in the desired direction

        float actMove[3];
        actMove[0] = gravObj->moveVect[0] * gravObj->curMoveSpeed + gravObj->tempVect[0] * gravObj->addMoveSpeed;
        actMove[1] = gravObj->moveVect[1] * gravObj->curMoveSpeed + gravObj->tempVect[1] * gravObj->addMoveSpeed;
        actMove[2] = gravObj->moveVect[2] * gravObj->curMoveSpeed + gravObj->tempVect[2] * gravObj->addMoveSpeed;

        float actMag = vectNorm(actMove, 3);

        if(actMag > gravObj->maxMoveSpeed) {
            if(gravObj->curMoveSpeed <= gravObj->maxMoveSpeed) {
                gravObj->curMoveSpeed = gravObj->maxMoveSpeed;
            } else {
                float diff = gravObj->curMoveSpeed - gravObj->maxMoveSpeed;
                if(diff > gravObj->addMoveSpeed) {
                    gravObj->curMoveSpeed -= gravObj->addMoveSpeed;
                } else {
                    gravObj->curMoveSpeed  += gravObj->addMoveSpeed;
                }
            }
        } else {
            gravObj->curMoveSpeed = actMag;
        }
        gravObj->moveVect[0] = actMove[0] / actMag;
        gravObj->moveVect[1] = actMove[1] / actMag;
        gravObj->moveVect[2] = actMove[2] / actMag;
    }

//    printf("typeIndex: %d\tJumping: %d\n", gravObj->typeIndex, gravObj->jumping);

    // Set the y to hug the ground.
    if(gravObj->typeIndex != 7) {
        // On the ground.
        if(gravObj->jumping) {
            // gravObj->moveVect[1] -= littleG * 5;
            float addVec[3] = {0, -littleG * 5, 0};
            addMoveVec(gravObj, addVec);
            gravObj->typeIndex = 7;
//            printf("\njumping\n\n");
        }
    } else {
//        printf()
        // I dont think this should be a thing.
        // In the air.
        struct jalbTerrain *colTer = gravObj->terArray[0];
//        arrayListGetPointer(terList, gravObj->chunkCoords)

        // Check Cur speed for Max speed.
        // hug the ground

        float *f0 = colTer->verts[colTer->faces[gravObj->faceIndex *3 + 0]].loc;
        float *f1 = colTer->verts[colTer->faces[gravObj->faceIndex *3 + 1]].loc;
        float *f2 = colTer->verts[colTer->faces[gravObj->faceIndex *3 + 2]].loc;

        float dx;
        float dz;
        axisAlignNewer(f0, f1, f2, &dx, &dz);

        // Set move vect y to the y in accordance to the face its on.
        gravObj->moveVect[1] = dx * gravObj->moveVect[0] + dz * gravObj->moveVect[2];

        //moveVec[1] = axisAlignNew(colFaceV0,colFaceV1,colFaceV2, moveVec[0], moveVec[2]);
        vectNormalize(gravObj->moveVect, 3);
    }
//    sayVect("madeMoveVect", gravObj->moveVect, 3);
//    printf("gravObj->curMoveSpeed: %f\n", gravObj->curMoveSpeed);
}

// Adding to moveVector.
void addMoveVec(struct jalbGravity *gravObj, float *addVec) {
//    sayVect("addMoveVec()", addVec, 3);
    float actVec[3];
    actVec[0] = gravObj->moveVect[0] * gravObj->curMoveSpeed + addVec[0];
    actVec[1] = gravObj->moveVect[1] * gravObj->curMoveSpeed + addVec[1];
    actVec[2] = gravObj->moveVect[2] * gravObj->curMoveSpeed + addVec[2];

//    sayVect("actVec", actVec, 3);

    gravObj->curMoveSpeed = vectNorm(actVec, 3);

    if(gravObj->curMoveSpeed != 0) {
        gravObj->moveVect[0] = actVec[0] / gravObj->curMoveSpeed;
        gravObj->moveVect[1] = actVec[1] / gravObj->curMoveSpeed;
        gravObj->moveVect[2] = actVec[2] / gravObj->curMoveSpeed;
    }
}

// The curMoveSpeed needs to be updated before this.
void singleVarGreater(struct jalbGravity *gravObj, float *diff, int index) {
    diff[0] += gravObj->tempVect[0] * gravObj->maxMoveSpeed;
    diff[1] += gravObj->tempVect[2] * gravObj->maxMoveSpeed;
    gravObj->curMoveSpeed += gravObj->addMoveSpeed;
    if(gravObj->curMoveSpeed > gravObj->maxMoveSpeed) {
        gravObj->curMoveSpeed = gravObj->maxMoveSpeed;
    }

    float tempMag = pow(diff[0] * diff[0] + diff[1] * diff[1], .5);
    printf("singleVarGreater: %f\n", tempMag);
    if(tempMag < gravObj->maxMoveSpeed) {
        // Scale it down, in accordance to non greater.
        sayVect("diffb4", diff, 3);
        diff[index] = pow(gravObj->curMoveSpeed * gravObj->curMoveSpeed - diff[1 - index] * diff[1 - index], .5);
        sayVect("diff", diff, 3);
    }

    gravObj->moveVect[0] = diff[0];
    gravObj->moveVect[2] = diff[1];
}

void gravMoveStart(struct jalbGravity *memObj, ArrayList *terList) {
    printf("Grav Move Start; curMoveSpeed: %f\n", memObj->curMoveSpeed);
    counter0 = 0;
    gravMove(memObj, terList);
}

void gravMove(struct jalbGravity *memObj, ArrayList *terList) {
    // Iterates the memObjs chunkArray for collision/adjustments.
    // If Collision ( If Grounded : If Airborn)
    // Else No Collision (If Grounded : If Airborn)

    sayVect("gravMove() StartLoc", memObj->position, 3);
    sayVect("gravMove() MoveVec", memObj->moveVect, 3);
    printf("midMoveSpeed: %f\n", memObj->midMoveSpeed);

    int chunkArrayCoords[7 * 2] = {0, 0, -1, 1, 0, 1, 1, 0, 1, -1, 0, -1, -1, 0};
    float terrainScale = jalbGravTerrainScale;
    float indentRadius = .51;
    float detectRadius = .5;
    //float groundedDetectRadius = .55;

    float actMoveVec[3];
    actMoveVec[0] = memObj->moveVect[0] * memObj->midMoveSpeed;
    actMoveVec[1] = memObj->moveVect[1] * memObj->midMoveSpeed;
    actMoveVec[2] = memObj->moveVect[2] * memObj->midMoveSpeed;

    // Iterate through the faces of this chunk.
    // Run circRayFaceScalar. Find the face with the lowest scalar.
    float lowBarys[2];
    int lowType = -1;
    int lowChunk = -1;
    int lowFace = -1;
    float lowScale = 1.0;

    int c;
    for(c = 0; c < 7; c++) {
        struct jalbTerrain *ter = memObj->terArray[c];
        int f;
        for (f = 0; f < ter->numFaces; f++) {
            if(f == memObj->faceIndex) {
                // Not going to collide with the face it is starting on.
                continue;
            }

            // New Face Verts.
            float *v0 = ter->verts[ter->faces[f *3 + 0]].loc;
            float *v1 = ter->verts[ter->faces[f *3 + 1]].loc;
            float *v2 = ter->verts[ter->faces[f *3 + 2]].loc;

            int retType = -1;
            float retBarys[2];

            float wx = 0;
            float wy = 0;
            terToWorldNew(chunkArrayCoords[c * 2], chunkArrayCoords[c * 2 + 1], &wx, &wy, terrainScale);

            float relPos[3];
            relPos[0] = memObj->position[0] - wx;
            relPos[1] = memObj->position[1];
            relPos[2] = memObj->position[2] - wy;

            float scale = newerCircRayFaceScalar(relPos, actMoveVec, detectRadius, v0, v1, v2, retBarys, &retType);

            if(scale >= 0) {
                printf("(lowFace: %d) (lowChunk: %d) (lowScale: %f)\n", f, c, scale);
            }
            // Could be positive, negative, nan. Sometimes [1] is -1.
            if(scale > 0 && scale < lowScale) {
                lowScale = scale;
                lowFace = f;
                lowChunk = c;
                lowType = retType;
                lowBarys[0] = retBarys[0];
                lowBarys[1] = retBarys[1];
            }

        }
    }

    if(lowFace != -1) {
        // There is a collision.
        printf("lowFace: %d\n", lowFace);
        struct jalbTerrain *colTer = memObj->terArray[lowChunk];

        float *colFaceV0 = colTer->verts[colTer->faces[lowFace *3 + 0]].loc;
        float *colFaceV1 = colTer->verts[colTer->faces[lowFace *3 + 1]].loc;
        float *colFaceV2 = colTer->verts[colTer->faces[lowFace *3 + 2]].loc;

        sayVect("colFaceV0", colFaceV0, 3);
        sayVect("colFaceV1", colFaceV1, 3);
        sayVect("colFaceV2", colFaceV2, 3);

        float v[3];
        vectSub(colFaceV1, colFaceV0, v, 3);
        float u[3];
        vectSub(colFaceV2, colFaceV0, u, 3);

        float normal[3];
        crossProd3(v, u, normal);
        vectNormalize(normal, 3);

        /// Handle New Chunk.
        if(lowChunk != 0) {
            // Change the chunkPos and then terAr.
            if(lowChunk == 1) {
                memObj->chunkCoords[0] -= 1;
                memObj->chunkCoords[1] += 1;
            } else if(lowChunk == 2) {
                memObj->chunkCoords[1] += 1;
            } else if(lowChunk == 3) {
                memObj->chunkCoords[0] += 1;
            } else if(lowChunk == 4) {
                memObj->chunkCoords[0] += 1;
                memObj->chunkCoords[1] -= 1;
            } else if(lowChunk == 5) {
                memObj->chunkCoords[1] -= 1;
            } else if(lowChunk == 6) {
                memObj->chunkCoords[0] -= 1;
            }
            fillTerArray(memObj, terList);
        }

        if(memObj->typeIndex != 7) {
            /// Not in the air
            // Reduce move speed.
            memObj->midMoveSpeed *= (1-lowScale);
            printf("lowScale: %f\n", lowScale);
//            printf("newMoveSpeed: %f\n", memObj->midMoveSpeed);
            // Make new moveVect.
            float dx;
            float dz;
            axisAlignNewer(colFaceV0, colFaceV1, colFaceV2, &dx, &dz);

            // Set move vect y to the y in accordance to the face its on.
            memObj->moveVect[1] = dx * memObj->moveVect[0] + dz * memObj->moveVect[2];
            vectNormalize(memObj->moveVect, 3);
        } else {
            /// In the air
            /// Make new moveVect.
            // Compute dot products
            float dot00 = dotProd(v, v, 3);
            float dot01 = dotProd(v, u, 3);
            // float dot02 = dotProd(v, v2, 3);
            float dot11 = dotProd(u, u, 3);
            // float dot12 = dotProd(u, v2, 3);

            // Compute barycentric coordinates.
            float invDenom = 1 / (dot00 * dot11 - dot01 * dot01);
            // memBary[0] = (dot11 * dot02 - dot01 * dot12) * invDenom;
            // memBary[1] = (dot00 * dot12 - dot01 * dot02) * invDenom;

            // Keeps the correct amount of momentum depending on moveVect and the faces angle.

            float velVec[3];
            velVec[0] = memObj->moveVect[0] * memObj->midMoveSpeed;
            velVec[1] = memObj->moveVect[1] * memObj->midMoveSpeed;
            velVec[2] = memObj->moveVect[2] * memObj->midMoveSpeed;

            float dot02 = dotProd(v, velVec, 3);
            float dot12 = dotProd(u, velVec, 3);

            // Compute barycentric coordinates.
            float tempBarys[2];
            tempBarys[0] = (dot11 * dot02 - dot01 * dot12) * invDenom;
            tempBarys[1] = (dot00 * dot12 - dot01 * dot02) * invDenom;

            memObj->moveVect[0] = v[0] * tempBarys[0] + u[0] * tempBarys[1];
            memObj->moveVect[1] = v[1] * tempBarys[0] + u[1] * tempBarys[1];
            memObj->moveVect[2] = v[2] * tempBarys[0] + u[2] * tempBarys[1];

            float ratio = vectNorm(memObj->moveVect, 3) / memObj->midMoveSpeed;

            memObj->midMoveSpeed *= ratio;
            memObj->curMoveSpeed *= ratio;

            vectNormalize(memObj->moveVect, 3);
        }

        /// Set memory. (Pos, Face, Type, Barys)

        sayVect("lowBarys", lowBarys, 2);

        // colLoc = v0 + v * b0 + u * b1 + normal * indentR;
        memObj->position[0] = colFaceV0[0] + v[0] * lowBarys[0] + u[0] * lowBarys[1] + normal[0] * indentRadius;
        memObj->position[1] = colFaceV0[1] + v[1] * lowBarys[0] + u[1] * lowBarys[1] + normal[1] * indentRadius;
        memObj->position[2] = colFaceV0[2] + v[2] * lowBarys[0] + u[2] * lowBarys[1] + normal[2] * indentRadius;

        memObj->faceIndex = lowFace;
        memObj->typeIndex = lowType;
        memObj->barys[0] = lowBarys[0];
        memObj->barys[1] = lowBarys[1];

        printf("\tGravMove Collision Recure\n\n");

        if(debug) {
            counter0++;
            if(counter0 > maxRec) {
                printf("Recure break 0\n");
//                sleep(4);
                exit(0);
            }
        }
        gravMove(memObj, terList);
    } else {
        // There is no collision.
//        printf("\tnoCollision\n");
        if(memObj->typeIndex != 7) {
            // Not in the air.
            groundedNoCollision(memObj, terList);
        } else {
            // In the air.
            // No collision, so in the air.
            memObj->faceIndex = -1;
            memObj->typeIndex = 7;

            memObj->position[0] += memObj->moveVect[0] * memObj->midMoveSpeed;
            memObj->position[1] += memObj->moveVect[1] * memObj->midMoveSpeed;
            memObj->position[2] += memObj->moveVect[2] * memObj->midMoveSpeed;

            // If the position is off edge of chunk:
            // Change coords, refill ter array, and change position.
            int edge = isOnEdgeNew(memObj->position[0], memObj->position[2], terrainScale);
            if(edge != -1) {
                // type did include corners, this converts it to be edge only.
                edge += 1;

                memObj->chunkCoords[0] += chunkArrayCoords[edge * 2];
                memObj->chunkCoords[1] += chunkArrayCoords[edge * 2 +1];

                /// Fix it: 2nd var, radius
                embedSpawnTer(terList, 4, memObj->chunkCoords[0], memObj->chunkCoords[1], jalbGravTerrainScale, jalbGravTerrainEdge);

                fillTerArray(memObj, terList);

                float wx = 0;
                float wy = 0;
                terToWorldNew(chunkArrayCoords[edge * 2], chunkArrayCoords[edge * 2 + 1], &wx, &wy, terrainScale);

                memObj->position[0] -= wx;
                memObj->position[2] -= wy;
            }
        }
    }
}

void groundedNoCollision(struct jalbGravity *memObj, ArrayList *terList) {
    printf("\tnoCollision\n");
    // No Collision.

    float indentRadius = .51;
    float terrainScale = jalbGravTerrainScale;

    float endVect[3];
    endVect[0] = memObj->position[0] + memObj->moveVect[0] * memObj->midMoveSpeed;
    endVect[1] = memObj->position[1] + memObj->moveVect[1] * memObj->midMoveSpeed;
    endVect[2] = memObj->position[2] + memObj->moveVect[2] * memObj->midMoveSpeed;

    struct jalbTerrain *ter = memObj->terArray[0];

    float *f0 = ter->verts[ter->faces[memObj->faceIndex *3 + 0]].loc;
    float *f1 = ter->verts[ter->faces[memObj->faceIndex *3 + 1]].loc;
    float *f2 = ter->verts[ter->faces[memObj->faceIndex *3 + 2]].loc;

    // End barys are being computed.
    float v[3];
    vectSub(f1, f0, v, 3);
    float u[3];
    vectSub(f2, f0, u, 3);
    float pv[3];
    vectSub(endVect, f0, pv, 3);

    // Compute dot products
    float dot00 = dotProd(v, v, 3);
    float dot01 = dotProd(v, u, 3);
    float dot02 = dotProd(v, pv, 3);
    float dot11 = dotProd(u, u, 3);
    float dot12 = dotProd(u, pv, 3);

    // Compute barycentric coordinates.
    float invDenom = 1 / (dot00 * dot11 - dot01 * dot01);
    float endBarys[3];
    endBarys[0] = (dot11 * dot02 - dot01 * dot12) * invDenom;
    endBarys[1] = (dot00 * dot12 - dot01 * dot02) * invDenom;
    endBarys[2] = 1 - endBarys[0] - endBarys[1];

    // If the end is on the face.
    if(endBarys[0] >= 0 && endBarys[1] >= 0 && endBarys[2] >= 0) {
//        printf("\tEnd On Face.\n");

        baryFacePoint(memObj->position, f0, f1, f2, endBarys);

        float normal[3];
        crossProd3(v, u, normal);

        vectScaleTo(normal, indentRadius, 3);

        vectAdd(memObj->position, normal, memObj->position, 3);

        memObj->barys[0] = endBarys[0];
        memObj->barys[1] = endBarys[1];

        memObj->typeIndex = 0;
    } else {
//        printf("\tend OFF face.\n");
        // The end is off the face, the start is on the face.
        // Find the leaving point + leaving edge.
        // See if the unit is on the leaving edge. If so switch face + recure.
        // If not on leaving edge, then move to leaving edge, switch face + recure.

        // Get Bary Ray.

        float memBary2 = 1 - memObj->barys[0] - memObj->barys[1];
//        sayVect("start barys", memObj->barys, 2);
//        printf("start bary2: %f\n", memBary2);

        float baryRay[3];

        baryRay[0] = endBarys[0] - memObj->barys[0];
        baryRay[1] = endBarys[1] - memObj->barys[1];
        baryRay[2] = endBarys[2] - memBary2;

//        sayVect("baryRay", baryRay, 3);

        float scalars[3];
        scalars[0] = -memObj->barys[0] / baryRay[0];
        scalars[1] = -memObj->barys[1] / baryRay[1];
        scalars[2] = -memBary2 / baryRay[2];

//        sayVect("offFaceScalars", scalars, 3);

        // if *memType is edge then look at ray direction. If the direction is off the edge, then slide.
        // If corner then do the same. if corner == 0 && -baryRay0 > -bR1  goTo v edge.
        // If *memType is face, then treat it normal.
        int lowest = -1;
        if (memObj->typeIndex == 0) {
//            printf("\tstartOnFace\n");
            // Start in face.
            // Find where the bary ray crosses the vect
            lowest = lowestPosFloat3(scalars[0], scalars[1], scalars[2]);
        } else if (memObj->typeIndex == 1) {
            // edge 0.
            // Do i just look at the stronger vector to figure which direction is more important. Incase 2 are negative.
            if (baryRay[1] < 0) {
                // Move vect leaves at this edge.
                // Set lowest and pass on.
                lowest = 1;
            } else {
                // Move vect leaves at another edge.
                // Find which edge it leaves from. How.
                if(scalars[0] >= 0) {
                    if(scalars[2] >= 0) {
                        if(scalars[2] < scalars[0]) {
                            // 2
                            lowest = 2;
                        } else {
                            // 0
                            lowest = 0;
                        }
                    } else {
                        // 0
                        lowest = 0;
                    }
                } else if(scalars[2] >= 0) {
                    // 2
                    lowest = 2;
                }
            }
        } else if (memObj->typeIndex == 2) {
            // edge 1.
            if (baryRay[0] < 0) {
                // Move vect leaves at this edge.
                // Set lowest and pass on.
                lowest = 0;
            } else {
                // Move vect leaves at another edge.
                // Find which edge it leaves from. How.
                if(scalars[1] >= 0) {
                    if(scalars[2] >= 0) {
                        if(scalars[2] < scalars[1]) {
                            // 2
                            lowest = 2;
                        } else {
                            // 1
                            lowest = 1;
                        }
                    } else {
                        // 1
                        lowest = 1;
                    }
                } else if(scalars[2] >= 0) {
                    // 2
                    lowest = 2;
                }
            }
        } else if (memObj->typeIndex == 3) {
            // edge 2.
            if (baryRay[2] < 0) {
                // Move vect leaves at this edge.
                // Set lowest and pass on.
                lowest = 2;
            } else {
                // Move vect leaves at another edge.
                // Find which edge it leaves from. How.

                if(scalars[0] >= 0) {
                    if(scalars[1] >= 0) {
                        if(scalars[1] < scalars[0]) {
                            // 1
                            lowest = 1;
                        } else {
                            // 0
                            lowest = 0;
                        }
                    } else {
                        // 0
                        lowest = 0;
                    }
                } else if(scalars[1] >= 0) {
                    // 1
                    lowest = 1;
                }
            }
        }

        // Ignore the corner, because the player will never walk them selves onto a corner.
        // The only way they are on a corner is if they start there / off the corner.
//        printf("memObj->typeIndex: %d\n", memObj->typeIndex);
        if (memObj->typeIndex == 4) {
            // f0.
            printf("BUG: On Corner, Not Handled.\n");
        } else if (memObj->typeIndex == 5) {
            // f1.
            printf("BUG: On Corner, Not Handled.\n");
        } else if (memObj->typeIndex == 6) {
            // f2.
            printf("BUG: On Corner, Not Handled.\n");
        } else {
            // If not a corner.
            /** Have lowest. do everything up-until recursion. */

            baryRay[0] *= scalars[lowest];
            baryRay[1] *= scalars[lowest];

            memObj->barys[0] += baryRay[0];
            memObj->barys[1] += baryRay[1];
            // Set bary[2].
            memBary2 = 1 - memObj->barys[0] - memObj->barys[1];

            float tempRay[3];
            tempRay[0] = baryRay[0] * v[0];
            tempRay[1] = baryRay[0] * v[1];
            tempRay[2] = baryRay[0] * v[2];

            tempRay[0] += baryRay[1] * u[0];
            tempRay[1] += baryRay[1] * u[1];
            tempRay[2] += baryRay[1] * u[2];
            float moveDist = vectNorm(tempRay, 3);
            printf("moveDist: %f\n", moveDist);

            memObj->midMoveSpeed -= moveDist;

            if(lowest == 0) {
                memObj->typeIndex = 2;
            } else if(lowest == 1) {
                memObj->typeIndex = 1;
            } else if(lowest == 2) {
                memObj->typeIndex = 3;
            }
        }

        // *memType is the edge leaving.
        // Im trying to edge the face entering.
        int v0;
        int v1;
//        printf("memObj->typeIndex: %d\n", memObj->typeIndex);
//        printf("memObj->faceIndex: %d\n", memObj->faceIndex);
        if(memObj->typeIndex == 1) {
            // e0
            v0 = ter->faces[memObj->faceIndex * 3];
            v1 = ter->faces[memObj->faceIndex * 3 + 1];
        } else if(memObj->typeIndex == 2) {
            // e1
            v0 = ter->faces[memObj->faceIndex * 3];
            v1 = ter->faces[memObj->faceIndex * 3 + 2];
        } else if(memObj->typeIndex == 3) {
            // e2
            v0 = ter->faces[memObj->faceIndex * 3 + 1];
            v1 = ter->faces[memObj->faceIndex * 3 + 2];
        }
        handleEdges(v0, v1, memObj, terrainScale, terList);

        if(memObj->faceIndex == -1) {
            printf("faceNextTo returned -1\n");
//                exit(0);
        }

        /// New Chunk.
        ter = memObj->terArray[0];

        /// New Face Verts.
        f0 = ter->verts[ter->faces[memObj->faceIndex *3 + 0]].loc;
        f1 = ter->verts[ter->faces[memObj->faceIndex *3 + 1]].loc;
        f2 = ter->verts[ter->faces[memObj->faceIndex *3 + 2]].loc;

        /// Set the unitLoc.
        // I can set unitLoc, and not set the characterLocation. Because char loc will be set once movement is done.
        // Unit loc == point on face + Y. Is making it go straight up a problem, because it not accurate?
        float nv[3];
        vectSub(f1, f0, nv, 3);
        float nu[3];
        vectSub(f2, f0, nu, 3);

        float normal[3];
        crossProd3(nv, nu, normal);

        vectScaleTo(normal, indentRadius, 3);

        memObj->position[0] = f0[0] + nv[0] * memObj->barys[0] + nu[0] * memObj->barys[1] + normal[0];
        memObj->position[1] = f0[1] + nv[1] * memObj->barys[0] + nu[1] * memObj->barys[1] + normal[1];
        memObj->position[2] = f0[2] + nv[2] * memObj->barys[0] + nu[2] * memObj->barys[1] + normal[2];

        /// Make New Move Vec.
        float dx;
        float dz;
        axisAlignNewer(f0, f1, f2, &dx, &dz);

        // Set move vect y to the y in accordance to the face its on.
        memObj->moveVect[1] = dx * memObj->moveVect[0] + dz * memObj->moveVect[2];
        vectNormalize(memObj->moveVect, 3);

        printf("Recure2\n");
        if(debug) {
            counter0++;
            if(counter0 > maxRec) {
                printf("recureBreak 1\n");
                // sleep(2);
                exit(0);
            }
        }
        gravMove(memObj, terList);
    }
}

// This is a big function that does a lot of stuff.
// I should document what it does and split it up appropriatly.
void handleEdges(int vi0, int vi1, struct jalbGravity *gravMem, float terrainScale, ArrayList *terList) {
//    printf("handleEdges()\n");
    int chunkArrayCoords[7 * 2] = {0, 0, -1, 1, 0, 1, 1, 0, 1, -1, 0, -1, -1, 0};

    struct jalbTerrain *ter = gravMem->terArray[0];

    float *vertLoc = ter->verts[vi0].loc;
    float *vertLoc1 = ter->verts[vi1].loc;

//    sayVect("vertLoc", vertLoc, 3);
//    sayVect("vertLoc1", vertLoc1, 3);

    int v0type = isOnEdge(vertLoc[0], vertLoc[2], terrainScale);
    int v1type = isOnEdge(vertLoc1[0], vertLoc1[2], terrainScale);

    //printf("vertTypes (%d, %d)\n", v0type, v1type);

    int retEdge;

    if(v0type == -1  || v1type == -1) {
        retEdge = findFaceNextToIndex(vi0, vi1, gravMem);

        // Handle ret edge. Do i want to do barys here? If not i need to return type.
    } else {

//        printf("\nTHIS FACE IS OFF EDGE\n\n");

        // Im looking for an the face on another chunk.
        // both vert types are not -1.

        // If the terrain radius is 1 then both indexes could be a corner.
        // But now atmost 1 will be corner and the other will be edge.
        if(v0type % 2 == 0) {
            // Its an even number meaning corner. So v1type has the edge index.
            v0type = v1type;
        }
        // type did include corners, this converts it to be edge only.
        v0type /= 2;
        v0type += 1;

        gravMem->chunkCoords[0] += chunkArrayCoords[v0type * 2];
        gravMem->chunkCoords[1] += chunkArrayCoords[v0type * 2 + 1];

        embedSpawnTer(terList, 4, gravMem->chunkCoords[0], gravMem->chunkCoords[1], jalbGravTerrainScale, jalbGravTerrainEdge);

        fillTerArray(gravMem, terList);

        gravMem->faceIndex = -1;

        float wx = 0;
        float wy = 0;

        terToWorldNew(chunkArrayCoords[v0type * 2], chunkArrayCoords[v0type * 2 + 1], &wx, &wy, terrainScale);

//        printf("world (%f, %f)\n", wx, wy);


        float tv0[3];
        tv0[0] = vertLoc[0] - wx;
        tv0[1] = vertLoc[1];
        tv0[2] = vertLoc[2] - wy;
        float tv1[3];
        tv1[0] = vertLoc1[0] - wx;
        tv1[1] = vertLoc1[1];
        tv1[2] = vertLoc1[2] - wy;

//        sayVect("tv0", tv0, 3);
//        sayVect("tv1", tv1, 3);

        // Find the face on the new chunk that shares the 2 vert locs.
        findFaceNextToSimple(tv0, tv1, &retEdge, gravMem);
    }

//    printf("retEdge: %d\n", retEdge);
//    printf("faceIndex: %d\n", gravMem->faceIndex);

    // handle ret edge.
    edgeChangeBarys(gravMem, retEdge);
    gravMem->typeIndex = retEdge + 1;

}

void edgeChangeBarys(struct jalbGravity *gravMem, int newEdge) {
    float *memBary = gravMem->barys;
    float memBary2 = 1 - memBary[0] - memBary[1];
    if (gravMem->typeIndex == 1 ) {
        // Leaving from e0 or e1.
        if(newEdge == 0) {
            memBary[0] = memBary[1];
            memBary[1] = 0.0;
        } else if(newEdge == 1) {
            memBary[1] = memBary[0];
            memBary[0] = 0;
        } else if(newEdge == 2) {
            // [0] = [0].
            // [1] = [1].
            // So don't do anything.

            // if mem == 1.
            // 0 = 0 | 1 = 1-0

            // old 0 = zero.

            // [1] = 1 - [0]
            // [2 - gravMem->typeIndex]
            memBary[1] = memBary2;
        }
    } else if (gravMem->typeIndex == 2) {
        // Leaving from e0 or e1.
        if(newEdge == 0) {
            memBary[0] = memBary[1];
            memBary[1] = 0.0;
        } else if(newEdge == 1) {
            memBary[1] = 1 - memBary[0];
            memBary[0] = 0;
        } else if(newEdge == 2) {
            // [0] = [0].
            // [1] = [1].
            // So don't do anything.

            // if mem == 2
            // 1 = 1 | 0 = 1-1

            // old 1 = zero.
            // [2 - gravMem->typeIndex]
            memBary[0] = memBary2;
        }
    } else if (gravMem->typeIndex == 3) {
        // Leaving from e2.
        if(newEdge == 0) {
            // [0] = [0].
            memBary[1] = 0;
        } else if(newEdge == 1) {
            memBary[0] = 0.0;
            // [1] = [1].
        } else if(newEdge == 2) {
            memBary[0] = memBary[1];
            memBary[1] = 1 - memBary[0];
        }
    }
}

void polyGrounded(struct jalbGravity *memObj, float detectDist, ArrayList *terList) {
//    worldToTer(memObj->position[0], memObj->position[2], &memObj->chunkCoords[0], &memObj->chunkCoords[1], 12);
//    printf("chunkCoords: (%d, %d)\n", memObj->chunkCoords[0], memObj->chunkCoords[1]);
    fillTerArray(memObj, terList);

    // Set it to in the air. Will remain like this until it is found on the ground.
    memObj->typeIndex = 7;
    float tempDist;
    int tempType;
    float tempBarys[2];
    int lowestChunk = -1;

    memObj->faceIndex = -1;

    // Chunk iterator.
    int c;
    for(c = 0; c < 7; c++) {
        struct jalbTerrain *chunk = memObj->terArray[c];
        printf("chunk: %p\n", chunk);
        int f;
        for (f = 0; f < chunk->numFaces; f++) {
            /// Point Face Dist.
//            printf("chunk: %p\n", chunk);
//            printf("f: %d\tnumFaces: %d\n", f, chunk->numFaces);
//            printf("chunk->faces[f * 3]: %d\n", chunk->faces[f * 3]);
            float *f0 = chunk->verts[chunk->faces[f *3 + 0]].loc;
            float *f1 = chunk->verts[chunk->faces[f *3 + 1]].loc;
            float *f2 = chunk->verts[chunk->faces[f *3 + 2]].loc;

            newPointFaceDist(memObj->position, f0, f1, f2, &tempDist, &tempType, tempBarys);

            // If the distance is less than the last best then save the return values.
            // printf("Face: %d\ttempDist: %f\tdetectDist: %f\n", f, tempDist, detectDist);
            if(tempDist < detectDist) {
                detectDist = tempDist;
                lowestChunk = c;
                // *retFace = f;
                memObj->faceIndex = f;
                // *retType = tempType;
                memObj->typeIndex = tempType;
                // retBarys[0] = tempBarys[0];
                // retBarys[1] = tempBarys[1];
                memObj->barys[0] = tempBarys[0];
                memObj->barys[1] = tempBarys[1];
            }
        }
    }
//    printf("lowestChunk: %d\n", lowestChunk);
    /// Fix It: This is only for testing purposes.
    if(memObj->typeIndex != 7) {
        if(lowestChunk != 0) {
            // Change the chunk indexs, then recreate terArray.
            printf("BUG: finish polyGrounded");
        }
    }
}

/* Col Type
 *  0 on face.
 *  1 on edge0 (f0, f1). (bary0 has relevent scalar)
 *  2 on edge1 (f0, f2).
 *  3 on edge2 (f1, f2).
 *  4 on corner f0.
 *  5 on corner f1.
 *  6 on corner f2.
 *  7 Distance under detectRadius.
 */

void newPointFaceDist(float *unitLoc, float *f0, float *f1, float *f2, float *retDist, int *retType, float *retBarys) {
//    sayVect("unitLoc", unitLoc, 3);
//    sayVect("f0", f0, 3);
//    sayVect("f1", f1, 3);
//    sayVect("f2", f2, 3);

    /// Point Face Bary Start.
    float v[3];
    vectSub(f1, f0, v, 3);
    float u[3];
    vectSub(f2, f0, u, 3);
    float pv[3];
    vectSub(unitLoc, f0, pv, 3);

    // Compute dot products
    float dot00 = dotProd(v, v, 3);
    float dot01 = dotProd(v, u, 3);
    float dot02 = dotProd(v, pv, 3);
    float dot11 = dotProd(u, u, 3);
    float dot12 = dotProd(u, pv, 3);

//    sayVect("v", v, 3);
//    sayVect("u", u, 3);
//    sayVect("pv", pv, 3);

    // Compute barycentric coordinates.
    float invDenom = 1 / (dot00 * dot11 - dot01 * dot01);
    retBarys[0] = (dot11 * dot02 - dot01 * dot12) * invDenom;
    retBarys[1] = (dot00 * dot12 - dot01 * dot02) * invDenom;
    /// Point Face Bary End.

//    sayVect("retBarys", retBarys, 2);

    if(retBarys[0] < 0) {
        // neg bary0 means edge1 (f0, f2)
        // Scalar of point projected onto edge.
        float scale = dot12 / dot11;
        oneCheck(scale, pv, f0, f2, v, retDist, retType);
//        printf("retType: %d\n", *retType);
        if (*retType == 0) {
            // edge1 (f0 f2).
            *retType = 2;
            retBarys[1] = scale;
        } else if (*retType == 1) {
            // corner f0.

            if(retBarys[1] < 0) {
                // Make a (f0, f1) scalar.
                scale = dot02 / dot00;
                oneCheck(scale, pv, f0, f1, u, retDist, retType);
                // Should be impossible for *retType == 2;
                if(*retType == 0) {
                    // edge f0 f1.
                    *retType = 1;
                    retBarys[0] = scale;
                } else if(*retType == 2) {
                    // corner f1
                    printf("\nnewPointFaceDist() Edge Glitch. *retType == 2\n\n");
                }
//                else if (*retType == 1){
//                  corner f0.
//                    *retType = 4;
//                }
            }

            *retType = 4;
        } else if (*retType == 2) {
            // corner f2.

            if(1 - retBarys[0] - retBarys[1] < 0) {
                float v2[3];
                vectSub(f2, f1, v2, 3);
                vectSub(unitLoc, f1, pv, 3);
                float scale = dotProd(v2, pv, 3) / dotProd(v2, v2, 3);

                oneCheck(scale, pv, f1, f2, v2, retDist, retType);
                // Should be impossible for *retType == 2;
                if(*retType == 0) {
                    // edge (f1, f2)
                    *retType = 3;
                    retBarys[0] = scale;
                } else if(*retType == 1) {
                    // corner f2.
                    printf("\nnewPointFaceDist() Edge Glitch. *retType == 2\n\n");
                }
//                else if (*retType == 2){
//                  corner f2.
//                    *retType = 6;
//                }
            }

            *retType = 6;
        }
    } else if(retBarys[1] < 0) {

        // off edge f0 f1.
        // all chances of 5
        float scale = dot02 / dot00;
        oneCheck(scale, pv, f0, f2, u, retDist, retType);
//        printf("retType: %d\n", *retType, 2);
        // Should be impossible for *retType == 2;
        if(*retType == 0) {
            // edge f0 f2.
            *retType = 2;
            retBarys[0] = scale;
        } else if(*retType == 2) {
            // corner f1.

            // bary2 might be negative so check it.

            if(1 - retBarys[0] - retBarys[1] < 0) {
                float v2[3];
                vectSub(f2, f1, v2, 3);
                vectSub(unitLoc, f1, pv, 3);
                float scale = dotProd(v2, pv, 3) / dotProd(v2, v2, 3);

                oneCheck(scale, pv, f1, f2, v2, retDist, retType);
                // Should be impossible for *retType == 2;
                if(*retType == 0) {
                    // edge (f1, f2)
                    *retType = 3;
                    retBarys[0] = scale;
                } else if(*retType == 2) {
                    // corner f2.
                    // *retType = 6;
                    printf("\nnewPointFaceDist() Edge Glitch. *retType == 2\n\n");
                }
//                else if (*retType == 1) {
                // corner f1.
//                    *retType = 5;
//                }
            }

            *retType = 5;
        } else if (*retType == 1) {
            // corner f0.
            *retType = 4;
            // Bary0 isnt negative so its just corner.
        }
    } else if (1 - retBarys[0] - retBarys[1] < 0) {
        // Off edge f1. f2
        // Construct the vect for the 3rd edge.
        float v2[3];
        vectSub(f2, f1, v2, 3);
        vectSub(unitLoc, f1, pv, 3);
        float scale = dotProd(v2, pv, 3) / dotProd(v2, v2, 3);

        oneCheck(scale, pv, f1, f2, v2, retDist, retType);
//        printf("retType: %d\n", *retType, 2);
        // Should be impossible for *retType == 2;
        if(*retType == 0) {
            // edge2 (f1, f2)
            *retType = 3;
            retBarys[0] = scale;
        } else if (*retType == 1) {
            // corner f1.
            *retType = 5;
        } else if(*retType == 2) {
            // corner f2.
            // I know that its not corner because bary[1] is not neg. But it can still be corner.
            *retType = 6;
        }
    } else {
        // On Face.
        // Compute retDist.
        v[0] *= retBarys[0];
        v[1] *= retBarys[0];
        v[2] *= retBarys[0];

        v[0] += u[0] * retBarys[1];
        v[1] += u[1] * retBarys[1];
        v[2] += u[2] * retBarys[1];

        v[0] -= pv[0];
        v[1] -= pv[1];
        v[2] -= pv[2];

        *retType = 0;
        *retDist = vectNorm(v, 3);
    }
}

void fillTerArray(struct jalbGravity *memObj, ArrayList *ters) {
    // I want to fill terArray in a specific way.
    // This helps because i will never need to search terArray since i know the relative position of every chunk just by indexing.
    // This will be useful when doing edgeDetection. Plug when moving to an adjacent chunk i can remember a few.

    // Iterate every chunk, make 7 checks.

    int numTers = arrayListGetLength(ters);

//    printf("Memobj (%d, %d)\n", memObj->chunkCoords[0], memObj->chunkCoords[1]);

    int i;
    for(i = 0; i < numTers; i++) {
        struct jalbTerrain *ter = arrayListGetPointer(ters, i);
//        printf("terPointer: %p\n", ter);
//        printf("Ter (%d, %d)\n", ter->chunkCoords[0], ter->chunkCoords[1]);
        if(ter->chunkCoords[0] == memObj->chunkCoords[0]) {
            if(ter->chunkCoords[1] == memObj->chunkCoords[1]) {
                // x, y
                memObj->terArray[0] = ter;
            } else if(ter->chunkCoords[1] == memObj->chunkCoords[1] +1) {
                // x, y+1
                memObj->terArray[2] = ter;
            } else if(ter->chunkCoords[1] == memObj->chunkCoords[1] -1) {
                // x, y-1
                memObj->terArray[5] = ter;
            }
        } else if(ter->chunkCoords[0] == memObj->chunkCoords[0] +1) {
            if(ter->chunkCoords[1] == memObj->chunkCoords[1]) {
                // x+1, y
                memObj->terArray[3] = ter;
            } else if(ter->chunkCoords[1] == memObj->chunkCoords[1] -1) {
                // x+1, y-1
                memObj->terArray[4] = ter;
            }
        } else if(ter->chunkCoords[0] == memObj->chunkCoords[0] -1) {
            if(ter->chunkCoords[1] == memObj->chunkCoords[1]) {
                // x-1, y
                memObj->terArray[6] = ter;
            } else if(ter->chunkCoords[1] == memObj->chunkCoords[1] +1) {
                // x-1, y+1
                memObj->terArray[1] = ter;
            }
        }
    }
}

void fillTerArraySplit(int *chunkCoords, struct jalbTerrain **terArray, ArrayList *ters) {
    // I want to fill terArray in a specific way.
    // This helps because i will never need to search terArray since i know the relative position of every chunk just by indexing.
    // This will be useful when doing edgeDetection. Plug when moving to an adjacent chunk i can remember a few.

    // Iterate every chunk, make 7 checks.

    int numTers = arrayListGetLength(ters);

//    printf("Memobj (%d, %d)\n", memObj->chunkCoords[0], memObj->chunkCoords[1]);

    int i;
    for(i = 0; i < numTers; i++) {
        struct jalbTerrain *ter = arrayListGetPointer(ters, i);
//        printf("terPointer: %p\n", ter);
//        printf("Ter (%d, %d)\n", ter->chunkCoords[0], ter->chunkCoords[1]);
        if(ter->chunkCoords[0] == chunkCoords[0]) {
            if(ter->chunkCoords[1] == chunkCoords[1]) {
                // x, y
                terArray[0] = ter;
            } else if(ter->chunkCoords[1] == chunkCoords[1] +1) {
                // x, y+1
                terArray[2] = ter;
            } else if(ter->chunkCoords[1] == chunkCoords[1] -1) {
                // x, y-1
                terArray[5] = ter;
            }
        } else if(ter->chunkCoords[0] == chunkCoords[0] +1) {
            if(ter->chunkCoords[1] == chunkCoords[1]) {
                // x+1, y
                terArray[3] = ter;
            } else if(ter->chunkCoords[1] == chunkCoords[1] -1) {
                // x+1, y-1
                terArray[4] = ter;
            }
        } else if(ter->chunkCoords[0] == chunkCoords[0] -1) {
            if(ter->chunkCoords[1] == chunkCoords[1]) {
                // x-1, y
                terArray[6] = ter;
            } else if(ter->chunkCoords[1] == chunkCoords[1] +1) {
                // x-1, y+1
                terArray[1] = ter;
            }
        }
    }
}

// Checks if a vert is past the edge of a chunk. If so return the edge that it is on.
int isOnEdge(float x, float y, int scale) {
//    printf("isOnEdge (%f, %f)\n", x, y);
    float round = .999;
    float smallNum = .001;

    if ( y >= sin(M_PI * 60 / 180) * scale * round) {
        if( fabs(x) * round <= cos(M_PI * 60 / 180) * scale) {
            // either 1 or tri edge.
            if ( fabs(y) >= ((scale - fabs(x)) * tan(60 * M_PI / 180)) * round ) {
                if(x < 0) {
                    return 2;
                } else {
                    return 4;
                }
            }
            return 3;
        }
    } else if ( y <= -sin(M_PI * 60 / 180) * scale * round) {
        if( fabs(x) * round <= cos(M_PI * 60 / 180) * scale) {
            if ( fabs(y) >= ((scale - fabs(x)) * tan(60 * M_PI / 180)) * round) {
                if(x < 0) {
                    return 10;
                } else {
                    return 8;
                }
            }
            return 9;
        }
    } else {
        if ( fabs(y) >= ((scale - fabs(x)) * tan(60 * M_PI / 180)) * round) {
            if(y < smallNum) {
                if( x < 0) {
                    return 0;
                } else {
                    return 6;
                }
            }
            if(y > 0) {
                if(x < 0) {
                    return 1;
                } else {
                    return 5;
                }
            } else {
                if(x < 0) {
                    return 11;
                } else {
                    return 7;
                }
            }
            return 1;
        }
    }
    return -1;
}

// Doesnt do corner detection.
int isOnEdgeNew(float x, float y, int scale) {
//    printf("isOnEdge (%f, %f)\n", x, y);
    float round = .999;

    if(fabs(x) >= cos(M_PI * 60 / 180) * scale * round) {
        // Past the middle section.
        if ( fabs(y) >= ((scale - fabs(x)) * tan(60 * M_PI / 180)) * round ) {
            //past the edge
            if(x > 0) {
                if(y > 0) {
                    return 2;
                } else {
                    return 3;
                }
            } else {
                if(y > 0) {
                    return 0;
                } else {
                    return 5;
                }
            }
        }
    } else {
        // x is in the middle section.
        if ( fabs(y) >= sin(M_PI * 60 / 180) * scale * round) {
            // y is past the edge.
            if(y > 0) {
                return 1;
            } else {
                return 4;
            }
        }
    }
    return -1;
}

void findFaceNextToSimple(float *vertLoc0, float *vertLoc1, int *retEdge, struct jalbGravity *gravMem) {
//    printf("findFaceNextToSimple()\n");
    /// I think this is done.
    // Return the index of the face that shares these 2 verts but is not old face.
    struct jalbTerrain *ter = gravMem->terArray[0];

    /// These vert comparisons are visually dirty.
// There may be bugs that i cant even see.
    // Iterate the entire vert

//    printf("ter->numFaces: %d\n", ter->numFaces);

    int f;
    for(f = 0; f < ter->numFaces; f++) {
        float temp[3];
        vectSub(vertLoc0, ter->verts[ter->faces[f *3 + 0]].loc, temp, 3);
        float dist = vectNorm(temp, 3);

        // vect0 of this face overlaps with vertLoc0
        if(dist < .001) {
//            printf("0-0 overlap.\n");
            // So check vect1 and vect2 to see if they overlap with verLoc1

            vectSub(vertLoc1, ter->verts[ter->faces[f *3 + 1]].loc, temp, 3);
            dist = vectNorm(temp, 3);
//            printf("dist: %f\n", dist);
            if(dist < .001) {
                // 0, 1
                gravMem->faceIndex = f;
                *retEdge = 0;
            } else {
                vectSub(vertLoc1, ter->verts[ter->faces[f *3 + 2]].loc, temp, 3);
                dist = vectNorm(temp, 3);
//                printf("dist: %f\n", dist);
                if(dist < .001) {
                    // 0,2
//                    printf("1-2 overlap.\n");
                    gravMem->faceIndex = f;
                    *retEdge = 1;
                }
            }
        } else {
            vectSub(vertLoc0, ter->verts[ter->faces[f *3 + 1]].loc, temp, 3);
            dist = vectNorm(temp, 3);
            if(dist < .001) {
                vectSub(vertLoc1, ter->verts[ter->faces[f *3 + 0]].loc, temp, 3);
                dist = vectNorm(temp, 3);
                if(dist < .001) {
                    // 1, 0
                    gravMem->faceIndex = f;
                    *retEdge = 0;
                } else {
                    vectSub(vertLoc1, ter->verts[ter->faces[f *3 + 2]].loc, temp, 3);
                    dist = vectNorm(temp, 3);
                    if(dist < .001) {
                        // 1, 2
                        gravMem->faceIndex = f;
                        *retEdge = 2;
                    }
                }
            } else {
                vectSub(vertLoc0, ter->verts[ter->faces[f *3 + 2]].loc, temp, 3);
                dist = vectNorm(temp, 3);
                if(dist < .001) {
                    vectSub(vertLoc1, ter->verts[ter->faces[f *3 + 0]].loc, temp, 3);
                    dist = vectNorm(temp, 3);
                    if(dist < .001) {
                        // 2, 0
                        gravMem->faceIndex = f;
                        *retEdge = 1;
                    } else {
                        vectSub(vertLoc1, ter->verts[ter->faces[f *3 + 1]].loc, temp, 3);
                        dist = vectNorm(temp, 3);
                        if(dist < .001) {
                            // 2, 1
                            gravMem->faceIndex = f;
                            *retEdge = 2;
                        }
                    }
                }
            }
        }
    }
}

// The indexes repeat so i can simply do
// Returns edge index, and sets faceIndex.
int findFaceNextToIndex(int v0, int v1, struct jalbGravity *gravMem) {
    struct jalbTerrain *ter = gravMem->terArray[0];

//    printf("findFaceNextToIndex(%d, %d)\n", v0, v1);

    int f;
    for(f = 0; f < ter->numFaces; f++) {
        if(f == gravMem->faceIndex) {
            // Cant return the current face.
            continue;
        }
        if(v0 == ter->faces[f * 3]) {
            if(v1 == ter->faces[f * 3 + 1]) {
                gravMem->faceIndex = f;
                return 0;
            } else if(v1 == ter->faces[f * 3 + 2]) {
                gravMem->faceIndex = f;
                return 1;
            }
        } else if(v0 == ter->faces[f * 3 + 1]) {
            if(v1 == ter->faces[f * 3]) {
                gravMem->faceIndex = f;
                return 0;
            } else if(v1 == ter->faces[f * 3 + 2]) {
                gravMem->faceIndex = f;
                return 2;
            }
        } else if(v0 == ter->faces[f * 3 + 2]) {
            if(v1 == ter->faces[f * 3]) {
                gravMem->faceIndex = f;
                return 1;
            } else if(v1 == ter->faces[f * 3 + 1]) {
                gravMem->faceIndex = f;
                return 2;
            }
        }
    }
    return -1;
}

void oneCheck(float scale, float *unitVec, float *f0, float *f1, float *edgeVec, float *retDist, int *retType) {
    if(scale < 0) {
        // corner f0
        *retDist = vectNorm(unitVec, 3);
        *retType = 1;
    } else if (scale > 1) {
        // corner f1
        float tempVert[3];
        tempVert[0] = f1[0] - unitVec[0];
        tempVert[1] = f1[1] - unitVec[1];
        tempVert[2] = f1[2] - unitVec[2];
        *retDist = vectNorm(tempVert, 3);
        *retType = 2;
    } else {
        // edge f0-f2
        float tempVert[3];
        // u * scale - pv
        tempVert[0] = edgeVec[0] * scale - unitVec[0];
        tempVert[1] = edgeVec[1] * scale - unitVec[1];
        tempVert[2] = edgeVec[2] * scale - unitVec[2];
        *retDist = vectNorm(tempVert, 3);
        *retType = 0;
    }
}

