#ifndef JALBGRAVITY_H
#define JALBGRAVITY_H

#include "jalbTerrain.h"
#include "jalbArrayList.h"

struct jalbGravity {
    float position[3];
    float rots[3];

    // Booleans.
    char locChanged;
    char rotChanged;

    int chunkCoordsOld[2];
    int chunkCoords[2];

    int faceIndex;
    int typeIndex;
    float barys[2];

    float tempVect[3];
    float moveVect[3];
    float maxMoveSpeed;
    float curMoveSpeed; // The character ticly speed.
    float addMoveSpeed; // The character max self acceleration.
    float midMoveSpeed; // Mid tic, calculation var.

    int jumping;

    void *terArray[7];
};

void setjalbGravity(struct jalbGravity *memObj, ArrayList *ters);
void makeMoveVect(struct jalbGravity *gravObj);
void singleVarGreater(struct jalbGravity *gravObj, float *vect, int index);
void addMoveVec(struct jalbGravity *gravObj, float *addVec);

void newestMove(struct jalbGravity *memObj, ArrayList *terList);

void gravMoveStart(struct jalbGravity *memObj, ArrayList *terList);
void gravMove(struct jalbGravity *memObj, ArrayList *terList);
void groundedNoCollision(struct jalbGravity *memObj, ArrayList *terList);

void newestMoveGrounded(struct jalbGravity *memObj, ArrayList *terList);
void newestMoveAir(struct jalbGravity *memObj, ArrayList *terList);

void handleEdges(int vi0, int vi1, struct jalbGravity *gravMem, float terrainScale, ArrayList *terList);
void edgeChangeBarys(struct jalbGravity *gravMem, int newEdge);

void polyGrounded(struct jalbGravity *memObj, float detectDist, ArrayList *terList);
void newPointFaceDist(float *unitLoc, float *f0, float *f1, float *f2, float *retDist, int *retType, float *retBarys);

void fillTerArray(struct jalbGravity *memObj, ArrayList *ters);
void fillTerArraySplit(int *chunkCoords, struct jalbTerrain **terArray, ArrayList *ters);
int isOnEdge(float x, float y, int scale);
int isOnEdgeNew(float x, float y, int scale);

void newerFindFaceNextTo(int vi0, int vi1, int *retEdge, struct jalbGravity *gravMem);
void findFaceNextToSimple(float *vertLoc0, float *vertLoc1, int *retEdge, struct jalbGravity *gravMem);
int findFaceNextToIndex(int v0, int v1, struct jalbGravity *gravMem);

void oneCheck(float scale, float *unitVec, float *f0, float *f1, float *edgeVec, float *retDist, int *retType);

#endif // JALBGRAVITY_H
