#ifndef JALBSERVER_H
#define JALBSERVER_H

#include <netinet/in.h>

#include "jalbArrayList.h"

enum servKeyMap {
    // Ogl Controls
    skmWalkForward,
    skmWalkBackwards,
    skmStrafeLeft,
    skmStrafeRight,
    skmRotateleft,
    skmRotateright,
    skmJump,

    skmHotBar0,
    skmHotBar1,
    skmHotBar2,
    skmHotBar3,
    skmHotBar4,
    skmHotBar5,

    numServKeyMaps,
};

enum serverOutput {
    soWakeup = 0,
    soNewGood,
    soNewBad,
    soLogGood,
    soLogBad,
    soInitTer,
    soInitEnt,
    soDisconnect,
    soUpdate,
    soTerUpdate,
    soEntUpdate,

    soNumOutputs,
};

enum entSubIds {
    soEntLoc = 0,
    soEntRot,
};

enum terSubIds {
    soTerVertMove = 0,
    soTerVertAdd,
    soTerFaceAdd,
};

enum clientOutput {
    coWakeup = 0,
    coNewAccount,
    coLogin,
    coDisconnect,
    coUpdate,
    coGameTic,

    coNumOutputs,
};

enum clientOutSub {
    cosKey = 0,
    cosMouse,
    cosSetRots,
};

enum profStage {
    psNotConn = 0,
    psKeyWait,
    psTerWait,
    psEntWait,
    psCapWait,
    psGame,

    numProfStage,
};

struct jalbProfile {
    unsigned char username[256];
    unsigned char password[256];

    int stage;
    int oldCounter;
    int curCounter;
    int failCount;

    int entity;
    int terRadius;

    unsigned char           key[16];
    // Set every connection.
    struct sockaddr_in      profAddr;
    socklen_t               addrLen;

    int                     keyMapBuf[numServKeyMaps];

    // Also uses fail counter.
    unsigned int            lastRecv;
    unsigned int            lastSent;
    // If i havent send for x seconds then resend.
    // If i havent recv for x seconds then resend.
    // If i havent recv for x * y seconds then disconnect.
};

#endif // JALBSERVER_H
