#ifndef JALBTERRAIN_H
#define JALBTERRAIN_H

#include "jalbArrayList.h"

//int chunkArrayCoords[7 * 2] = {0, 0, -1, 1, 0, 1, 1, 0, 1, -1, 0, -1, -1, 0};

struct vertTex {
    float loc[3];
    int texi;
};

// (faces, uvs) length = numFaces.
// verts length = numVerts
struct jalbTerrain {
    int numVerts;
    int numFaces;

    int maxVerts;
    int maxFaces;

    int chunkCoords[2];

    struct vertTex *verts; // ( 3 floats + 1 int ) per vert.
    int *faces; // 3 ints per face

    ArrayList *movedVerts; // Should not have any repeating numbers.
};


struct jalbTerrain *initTerrain(int edge, int x, int y, float scale);
struct jalbTerrainMin *initTerrainMin(int edge, int x, int y, float scale);

/// Indexing + Total.
int numHexVerts(int radius);
int numHexFaces(int radius);

/// Array Generation.
int *genHexFace(int radius, int *faces);
struct vertTex *genHexVerts(int radius, float scale, struct vertTex *verts);

void worldToTer(float wx, float wz, int *terX, int *terZ, float scale);
void terToWorld(int tx, int ty, float *wx, float *wy, float scale);
void terToWorldNew(int tx, int ty, float *wx, float *wy, float scale);

int loadWorld(char *dir, ArrayList *chunkList);

void checkAndSpawn(ArrayList *terList, int coX, int coY, float scale, int edge);
void embedSpawnTer(ArrayList *terList, int radius, int coX, int coY, float scale, int edge);

struct jalbTerrain *coordsToTer(int *inCoords, ArrayList *terList);

#endif // JALBTERRAIN_H
