#ifndef JAMA_H
#define JAMA_H

void matMatMult(float *mat1, float *mat2);

void xRotMatrix4(float *mat, float thea);
void yRotMatrix4(float *mat, float thea);
void zRotMatrix4(float *mat, float thea);

void matVectMult(float *mat, float *vect, float *newVect);
void matVect3Mult(float *mat, float *vect, float *newVect);

/** Vector math */

void vectAdd(float *v1, float *v2, float *vSet, int length);
void vectSub(float *v1, float *v2, float *vSet, int length);
void vectMultScalar(float *vect, float scalar, int length);

float dotProd(float *vect1, float *vect2, int length);

float vectNorm(float *vec, int length);
void vectNormalize(float *vec, int length);

void crossProd3(float *v1, float *v2, float *vSet);

void vectScaleTo(float *vect, float scalar, int length);

void axisAlignNewer(float *f0, float *f1, float *f2, float *dx, float *dz);

void quadEq(float a, float b, float c, float *ret);

/** Data Comparison */
int lowestPosFloat3(float f0, float f1, float f2);

/** Saying */

void sayMat4(char *str, float *mat);
void sayVect(char *str, float *vect, int length);

float *crossProduct3(float *v1, float *v2);

int vectVectSame(float *v0, float *v1, int length);

#endif // JAMA_H
